#jinja2: trim_blocks: True, lstrip_blocks: True
{{ ansible_managed | comment }}

{#  an opinionated website virtual host

    # the vhost name (primary domain name)
    item.name: string
    # the vhost domain list
    item.domain: string[] | d([])
    # the vhost admin contact
    item.admin: string
    # the vhost root directory
    item.root: string
    # the vhost virtual root
    item.virtual_root: string | d(omit)
    # the vhost ssl capability
    item.ssl: boolean | d('no')
    # redirect the non-ssl vhost to ssl counterpart
    item.redirect_ssl: boolean | d('yes')

    # the vhost network bind interface
    item.bind: string | d(apache2_network_bind)
    # the vhost network port
    item.port: int | d(apache2_network_port)
    # the vhost network ssl port
    item.ssl_port: int | d(apache2_network_ssl_port)

    # the vhost error log
    item.error_log: string
    # disable the vhost error log
    item.no_error_log: boolean | d('no')
    # the vhost access log
    item.access_log: string
    # the vhost access log format
    item.access_log_format: string | d(apache2_access_log_format)
    # disable the vhost access log
    item.no_access_log: boolean | d('no')

    # the vhost ssl certificate
    item.ssl_cert: string
    # the vhost ssl certificate key
    item.ssl_cert_key: string
    # the vhost ssl certificate chaine
    item.ssl_cert_chain: string | d(omit)

    # the vhost snippet list
    item.snippet: dict[] | d([])
    # - name: string
    #   http: boolean | d('yes')
    #   ssl: boolean | d('yes')

    # the vhost raw configuration
    #item.raw:
    # the vhost raw ssl configuration.  default: `item.raw`
    #item.ssl_raw: "{{ item.raw }}"
-#}

<VirtualHost {{ item.bind | d(apache2_network_bind) }}:{{ item.port | d(apache2_network_port) }}>
    ServerName {{ item.name | mandatory }}
    {% if item.domain | d([]) | length > 0 %}
    ServerAlias {{ item.domain | join(' ') }}
    {% endif %}
    {% if item.admin | d('') | length > 0 %}
    ServerAdmin {{ item.admin }}
    {% endif %}
    {% if item.virtual_root is defined %}
    VirtualDocumentRoot {{ item.virtual_root | mandatory }}
    {% else %}
    DocumentRoot {{ item.root | mandatory }}
    {% endif %}

    {% if not item.no_error_log |d ('no') | bool %}
    ErrorLog {{ item.error_log | d(apache2_logdir ~ "/" ~ item.name | mandatory ~ ".error_log") }}
    {% endif %}
    {% if not item.no_access_log | d('no') | bool %}
    CustomLog {{ item.access_log | d(apache2_logdir ~ "/" ~ item.name | mandatory ~ ".access_log") }} {{ item.access_log_format | d(apache2_access_log_format) }}
    {% endif %}

    <Directory "{{ item.root | mandatory }}">
        Options Indexes SymLinksIfOwnerMatch
        AllowOverride All
        Require all granted
    </Directory>

    {% if item.ssl | d('no') | bool and item.redirect_ssl | d('yes') | bool %}
    Include {{ apache2_confdir }}/snippet.d/redirect-ssl.conf
    {% endif %}
    {% for _apache2_snippet in item.snippet | d([]) %}
    {% if _apache2_snippet.http | d('yes') | bool %}
    Include {{ _apache2_snippet.name | mandatory }}
    {% endif %}
    {% endfor %}

{% if item.raw | d('') | length > 0 %}
{{ item.raw | indent(4, True) }}
{% endif %}
</VirtualHost>
{% if item.ssl | d('no') | bool %}

<IfModule mod_ssl.c>
    <VirtualHost {{ item.bind | d(apache2_network_bind) }}:{{ item.ssl_port | d(apache2_network_ssl_port) }}>
        ServerName {{ item.name | mandatory }}
        {% if item.domain | d([]) | length > 0 %}
        ServerAlias {{ item.domain | join(' ') }}
        {% endif %}
        {% if item.admin | d('') | length > 0 %}
        ServerAdmin {{ item.admin }}
        {% endif %}
        DocumentRoot {{ item.root | mandatory }}

        {% if not item.no_error_log |d ('no') | bool %}
        ErrorLog {{ item.error_log | d(apache2_logdir ~ "/" ~ item.name | mandatory ~ ".error_log") }}
        {% endif %}
        {% if not item.no_access_log | d('no') | bool %}
        CustomLog {{ item.access_log | d(apache2_logdir ~ "/" ~ item.name | mandatory ~ ".access_log") }} {{ item.access_log_format | d(apache2_access_log_format) }}
        {% endif %}

        SSLEngine on
        SSLCertificateFile {{ item.ssl_cert | mandatory }}
        SSLCertificateKeyFile {{ item.ssl_cert_key | mandatory }}
        {% if item.ssl_cert_chain | d('') | length > 0 %}
        SSLCertificateChainFile {{ item.ssl_cert_chain | mandatory }}
        {% endif %}

        <Directory "{{ item.root | mandatory }}">
            Options Indexes SymLinksIfOwnerMatch
            AllowOverride All
            Require all granted
        </Directory>

        {% for _apache2_snippet in item.snippet | d([]) %}
        {% if _apache2_snippet.ssl | d('yes') | bool %}
        Include {{ _apache2_snippet.name | mandatory }}
        {% endif %}
        {% endfor %}

{% if item.ssl_raw | d(item.raw | d('')) | length > 0  %}
{{ item.ssl_raw | d(item.raw) | indent(8, True) }}
{% endif %}
    </VirtualHost>
</IfModule>
{% endif %}
